/*
 * $Id: AmRtpPacket.h,v 1.6 2004/06/09 09:39:16 rco Exp $
 *
 * Copyright (C) 2002-2003 Fhg Fokus
 *
 * This file is part of sems, a free SIP media server.
 *
 * sems is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version
 *
 * For a license to use the ser software under conditions
 * other than those described here, or to purchase support for this
 * software, please contact iptel.org by e-mail at the following addresses:
 *    info@iptel.org
 *
 * sems is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this program; if not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
#ifndef _AmRtpPacket_h_
#define _AmRtpPacket_h_

#include <sys/types.h>
#include <netinet/in.h>

class AmRtpPacketTracer;

class AmRtpPacket {

    unsigned char* buffer;
    unsigned int   b_size;

    unsigned char* data;
    unsigned int   d_size;

public:
    unsigned char  payload;
    bool           marker;
    unsigned short sequence;    
    unsigned int   timestamp;   
    unsigned int   ssrc;

    AmRtpPacket();
    ~AmRtpPacket();

    // returns -1 if error, else 0
    int compile(unsigned char* data_buf, unsigned int size);
#ifdef SUPPORT_IPV6
    int send(int sd, const struct sockaddr_storage* saddr);
    int recv(int sd, struct sockaddr_storage* recv_addr);
#else
    int send(int sd, const struct sockaddr_in* saddr);
    int recv(int sd, struct sockaddr_in* recv_addr);
#endif

    int parse();

    unsigned int   getDataSize() { return d_size; }
    unsigned char* getData() { return data; }

    friend class AmRtpPacketTracer;
};

#endif

// Local Variables:
// mode:C++
// End:

