/*
 * $Id: Bot.h,v 1.2 2003/11/25 16:19:18 rco Exp $
 *
 * Copyright (C) 2002-2003 Fhg Fokus
 *
 * This file is part of sems, a free SIP media server.
 *
 * sems is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * For a license to use the sems software under conditions
 * other than those described here, or to purchase support for this
 * software, please contact iptel.org by e-mail at the following addresses:
 *    info@iptel.org
 *
 * sems is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this program; if not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef BOT_H
#define BOT_H

#include "AmApi.h"
#include "AmServer.h"

class BotStateFactory: public AmStateFactory, public AmServerFct
{
 public:
    BotStateFactory(const string& _app_name);

    // AmStateFactory interface
    int onLoad();
    AmDialogState* onInvite(AmCmd& cmd);

    // AmServerFct interface
    int execute(FILE* stream, const string& cmd_str);
};

class BotDialog : public AmDialogState
{
 public:
    BotDialog();
    ~BotDialog();

    void onSessionStart(AmRequest* req);
    void onBye(AmRequest* req);
};

#endif
// Local Variables:
// mode:C++
// End:
