/*
 * $Id: Conference.h,v 1.4 2004/01/20 10:50:42 rco Exp $
 *
 * Copyright (C) 2002-2003 Fhg Fokus
 *
 * This file is part of sems, a free SIP media server.
 *
 * sems is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * For a license to use the sems software under conditions
 * other than those described here, or to purchase support for this
 * software, please contact iptel.org by e-mail at the following addresses:
 *    info@iptel.org
 *
 * sems is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this program; if not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef _CONFERENCE_H_
#define _CONFERENCE_H_

#include "AmApi.h"
#include "AmThread.h"

#include <map>
#include <string>
using std::map;
using std::string;

class ConferenceStatus;
class ConferenceStatusContainer;

class ConferenceFactory : public AmStateFactory
{
    ConferenceStatusContainer* status_container;

public:
    static string LonelyUserFile;
    static string TracePath;

    ConferenceFactory(const string& _app_name);
    virtual AmDialogState* onInvite(AmCmd&);
    virtual int onLoad();
};

class ConferenceDialog : public AmDialogState
{
    string conf_id;
    AmCondition<bool> unbound2status;
    
public:
    int channel_id;

    ConferenceDialog(const string& conf_id);
    ~ConferenceDialog();
    void onSessionStart(AmRequest* req);
    void onBye(AmRequest* req);
    int onOther(AmSessionEvent* event);

    void unbind();
};

#endif
// Local Variables:
// mode:C++
// End:

