/*
 * $Id: MultiPartyMixerSocket.cpp,v 1.4 2004/01/30 18:13:58 rco Exp $
 *
 * Copyright (C) 2002-2003 Fhg Fokus
 *
 * This file is part of sems, a free SIP media server.
 *
 * sems is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * For a license to use the sems software under conditions
 * other than those described here, or to purchase support for this
 * software, please contact iptel.org by e-mail at the following addresses:
 *    info@iptel.org
 *
 * sems is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this program; if not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "MultiPartyMixerSocket.h"

#include "MultiPartyMixer.h"
#include "amci/codecs.h"

#include <assert.h>

int MultiPartyMixerSocket::streamPut(unsigned int user_ts, unsigned int size)
{
    mixer->PutChannelPacket(channel,user_ts,samples,size,begin_talk);
    return size;
}

int MultiPartyMixerSocket::streamGet(unsigned int user_ts, unsigned int size)
{
    mixer->GetChannelPacket(channel,user_ts,samples,size);
    return size;
}

MultiPartyMixerSocket::MultiPartyMixerSocket(MultiPartyMixer* mixer, Type type, 
					     unsigned int channel )
    : mixer(mixer), channel(channel)
{
    AmAudioSimpleFormat* fmt = new AmAudioSimpleFormat(CODEC_PCM16);

    if(type == Play)   in.reset(fmt);
    else if(type == Record) out.reset(fmt);
    else assert(0);
}

MultiPartyMixerSocket::~MultiPartyMixerSocket()
{
}
