#ifdef USE_CAPI20

#ifndef _ISDNCAPIUTIL_H_
#define _ISDNCAPIUTIL_H_

#include <capi20.h>

/* number types */
#define TYPE_CALLEE 0
#define TYPE_CALLER 1
#define TYPE_CALLER_SUPPRESS 2

#define MSG_SIZE 1024
#define MAX_CONN 100

#define FAIL 0
#define OK 1

class IsdnCapiUtil {
	
	public:
	
	/* method for directly sending _cmsg objects. */
	static int putMessage(_cmsg *msg, unsigned int appId=0);
	
	/* creates a CAPI compliant number struct */
	static int build_number(int type, unsigned char* buf, int len, const char* number);

	/* used for bit debugging */
	static void getBits(unsigned char data, char* buf, int reversed);

	/* convert reversed-bit alaw to alaw for memory beginning in start */
	static void reverseBits(unsigned char* start, unsigned int len);

	private:
	
	/* 0100 1000 -> 0001 0010, needed to convert reversed-bit aLaw to normal aLaw */
	static void reverseBits(unsigned char *data);
 
};
#endif /*header*/
#endif /*USE_CAPI20*/

