/*
 * $Id: IsdnGatewayFactory.h,v 1.5 2004/04/01 14:47:23 ullstar Exp $
 *
 * Copyright (C) 2003 Ulrich Abend
 *
 * This file is part of isdngw, a free isdn gateway plugin 
 * for sems, a free SIP media server.
 *
 * isdngw is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version
 *
 * For a license to use the ser software under conditions
 * other than those described here, or to purchase support for this
 * software, please contact iptel.org by e-mail at the following addresses:
 *    info@iptel.org
 *
 * isdngw is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this program; if not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef _ISDNGATEWAYFACTORY_H_
#define _ISDNGATEWAYFACTORY_H_

#include "AmApi.h"
#ifdef USE_CAPI20
#include "IsdnCapiConnectionManager.h"
#endif


#define DEVICE_NO_DEVICE -1
#define DEVICE_I4L 0

#ifdef USE_CAPI20
#define DEVICE_CAPI_CONTR1 1
#define DEVICE_CAPI_CONTR2 2
#define DEVICE_CAPI_CONTR3 3
/* ... */

#endif

#define FIFO_WEB_FUNC "isdninfo"

/** Implements a SIP2PSTN gateway. This class implements the plugin API of
 * sems, a free SIP media server.
 *
 * isdngw uses sems for several purposes:
 *  - connection to SER (Sip Express Router)
 *  - SIP session handling
 *  - codecs for audio transformation
 *  - logging
 * 
 * To interact with PSTN lines it uses Isdn4Linux's ttyI devices.
 * 
 */
class IsdnGatewayFactory: public AmStateFactory
{
public:
  IsdnGatewayFactory(const string& _app_name); 
  ~IsdnGatewayFactory(); 
//  virtual AmDialogState* createState(AmRequest&); 
  virtual AmDialogState* onInvite(AmCmd& req); //< Process an incoming SIP call
	
	int onLoad();

};

#endif
