/*
 * $Id: IsdnUtils.h,v 1.4 2003/12/04 10:12:17 ullstar Exp $
 *
 * Copyright (C) 2003 Ulrich Abend
 *
 * This file is part of isdngw, a free isdn gateway plugin 
 * for sems, a free SIP media server.
 *
 * isdngw is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version
 *
 * For a license to use the ser software under conditions
 * other than those described here, or to purchase support for this
 * software, please contact iptel.org by e-mail at the following addresses:
 *    info@iptel.org
 *
 * isdngw is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this program; if not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef _ISDNUTILS_H_
#define _ISDNUTILS_H_

#include "AmApi.h"
#include "globals.h" 

/** Static helper functions for communication with isdn devices.
 */
class IsdnUtils {
private:
	static int complete_response (char* buf);
	static void stripresult (char* buf);
	
public:
	static int nb_write(int fd, char* buf);
	static int nb_read_answer(int fd, char* buf, char options = NO_OPTIONS, int custom_timeout = -1);
	static int extractNumberOnCall(char *buf, char *callednumberbuf);

	static void determineNumbers(AmRequest *req, char* phonenumber, char* msn, int buflens);
	static void determineNumbers(AmCmd cmd, char* phonenumber, char* msn, int buflens);

	static void buildSipUri(char* buf, int len, char* number, bool caller);
};

#define BUFSIZE 45

#endif 
