/*
 * $Id: globals.h,v 1.4 2004/03/29 16:40:02 ullstar Exp $
 *
 * Copyright (C) 2003 Ulrich Abend
 *
 * This file is part of isdngw, a free isdn gateway plugin 
 * for sems, a free SIP media server.
 *
 * isdngw is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version
 *
 * For a license to use the ser software under conditions
 * other than those described here, or to purchase support for this
 * software, please contact iptel.org by e-mail at the following addresses:
 *    info@iptel.org
 *
 * isdngw is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this program; if not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/** \file globals.h Global defines and constants go here. Every cpp 
 * file should include this header. 
 */

#ifndef _GLOBALS_H_
#define _GLOBALS_H_

#define MODULE_NAME "isdngw"

/** code for errors of any kind, i don't like all this impliciteness of c :-) */
#define FAIL 0
/** code for success */
#define OK 1

/** no special options are def'd for this chatlist item */
#define NO_OPTIONS 0x00
/** this chat list item is not required for a successful chat. */
#define OPTION_NOT_REQUIRED 0x01
/** this chat list item says: end the voice connection */
#define OPTION_END_VOICE 0x04
/** chat list item should/can be retryed */
#define OPTION_RETRY 0x08
/** don't strip the modem response, needed for number detection */
#define OPTION_DONT_STRIP 0x10

/** timeout before reiniting unanswered number devices in seconds*/
#define INCOMING_REINIT_TIMEOUT 10000

/** timeout waiting for an answer on SIP side for incoming calls in seconds */
#define INCOMING_CALL_ACCEPT_TIMEOUT 30

/** default lockfile prefix (standard uucp style) */
#define LOCKFILE_PREFIX "/LCK.."
/** default lockfile location. Change in configfile for non-privileged mode */
#define LOCKDIR_DEFAULT "/var/lock"

#define TTYI_DEVICE_PREFIX "/dev/ttyI"

#define INCOMING_KEY_PREFIX "__"

#define MAX_NUM_LEN 20
#define MAX_URI_LEN 1024

#define MAX_CAPI_CONTROLLERS 8

#endif 
