/*
 * $Id: AmAudioIvr.cpp,v 1.6 2004/05/11 07:39:08 ilk Exp $
 * Copyright (C) 2002-2003 Fhg Fokus
 *
 * This file is part of sems, a free SIP media server.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
#include "log.h"
#include "AmAudioIvr.h"



int AmAudioIvr::streamGet(unsigned int user_ts, unsigned int size)
{
/*    unsigned int p_size = packet_size[current_buf & BUFFER_MASK];
    unsigned char* offset = audio_buf
	+ ( ((current_buf - lag) & BUFFER_MASK) * AUDIO_BUFFER_SIZE);

    unsigned int m_size = size < p_size ? size : p_size;
    memcpy((unsigned char*)samples,offset,m_size);
    //DBG("size=%i\n",m_size);
    return m_size;
*/
   return 1;
}

int AmAudioIvr::streamPut(unsigned int user_ts, unsigned int size)
{
   unsigned int samplesOffset = 0;
   pthread_mutex_lock(&mutexAmAudioIvr);
   //DBG("Return Code : %i",fwrite(samples,sizeof(char),size,fd));
   while( samplesOffset < size ){
      unsigned int memcpySize = (AUDIO_FRAME_SIZE - audioFrameOffset) < (size - samplesOffset) ? (AUDIO_FRAME_SIZE - audioFrameOffset):(size - samplesOffset);
      memcpy(audioFrame + audioFrameOffset, samples + samplesOffset, memcpySize);
      audioFrameOffset += memcpySize;
      samplesOffset+=memcpySize;
      if(audioFrameOffset >= AUDIO_FRAME_SIZE){
         audioFrameFull[audioFrameCount & BUFFER_MASK] = true;
         audioFrameCount++;
         audioFrame = audioBuffer + (audioFrameCount & BUFFER_MASK) * AUDIO_FRAME_SIZE;
         audioFrameOffset = 0;
      }
     
   }
   pthread_mutex_unlock(&mutexAmAudioIvr);
   return size;    
}


AmAudioIvr::AmAudioIvr()
   : AmAudio()
  //  : lag(lag)
{
    closed = false;
    audioFrameOffset = 0;
    audioFrameCount = 0;
    getAudioFrameCount = 0;
    audioFrame = audioBuffer;
    memset(audioBuffer,0,AUDIO_FRAME_SIZE*NB_BUFFERS);
    memset(audioFrameFull,false,NB_BUFFERS);
    pthread_mutex_init(&mutexAmAudioIvr, NULL);

    //fd=fopen("lala","w");    
    out.reset(new AmAudioIvrFormat());
}

AmAudioIvr::~AmAudioIvr()
{
   pthread_mutex_destroy(&mutexAmAudioIvr);
}

int AmAudioIvr::getAudioFrame(unsigned char* extBuffer)
{
   if(closed)
      return -2;
   if(audioFrameFull[getAudioFrameCount&BUFFER_MASK]){
      pthread_mutex_lock(&mutexAmAudioIvr);
      memcpy(extBuffer, audioBuffer + (getAudioFrameCount & BUFFER_MASK) * AUDIO_FRAME_SIZE, AUDIO_FRAME_SIZE);
      audioFrameFull[getAudioFrameCount&BUFFER_MASK] = false;
      getAudioFrameCount++;
      pthread_mutex_unlock(&mutexAmAudioIvr);
      return 1;
   }
   else
      return 0;        
}

void AmAudioIvr::close(){
   closed = true;
}


/*  IVR audio format. This subclass just sets the appropriate
 *  members of AmAudioFormat and initializes the codec.
 */
AmAudioIvrFormat::AmAudioIvrFormat() {
	channels = IVR_AUDIO_CHANNELS;
	rate = IVR_AUDIO_RATE;
	sample = IVR_AUDIO_SAMPLE;
	/* initialize the codec */
	codec = getCodec();
	initCodec();
	if (!codec)
		INFO("ERROR: could not initialize ivr codec!\n");
	/* this is probably to state: we have a running codec */
	h_codec=1;
}

int AmAudioIvrFormat::getCodecId() {
	return (IVR_AUDIO_CODEC);
}	
