/*
 * $Id: AmAudioIvr.h,v 1.4 2003/11/25 12:04:56 ilk Exp $
 * Copyright (C) 2002-2003 Fhg Fokus
 *
 * This file is part of sems, a free SIP media server.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
 
#ifndef _AM_AUDIO_IVR_H_
#define _AM_AUDIO_IVR_H_

#include "AmAudio.h"
#include "IvrDtmf.h"

/** ivr audio is mono */
#define IVR_AUDIO_CHANNELS 1
/** ivr audio sample rate is 8000 */
#define IVR_AUDIO_RATE 8000
/** one sample per frame */
#define IVR_AUDIO_SAMPLE 1
/** ivr codec */
#define IVR_AUDIO_CODEC 1

#define NB_BUFFERS  16
#define BUFFER_MASK (NB_BUFFERS-1)
#define AUDIO_FRAME_SIZE  NUMBER_OF_SAMPLES * sizeof(pcm)


class AmAudioIvr : public AmAudio
{
    FILE* fd;
    unsigned char audioBuffer[AUDIO_FRAME_SIZE * NB_BUFFERS];
    bool audioFrameFull[NB_BUFFERS];
    unsigned int  audioFrameOffset;
    unsigned int audioFrameCount;
    unsigned int getAudioFrameCount;
    unsigned char* audioFrame;
    pthread_mutex_t mutexAmAudioIvr;
    bool closed;

    int streamGet(unsigned int user_ts, unsigned int size);
    int streamPut(unsigned int user_ts, unsigned int size);

public:
    AmAudioIvr();
    ~AmAudioIvr();
    int getAudioFrame(unsigned char* extBuffer);
    void close();
};

// IVR audio format description. 
class AmAudioIvrFormat : public AmAudioFormat
{
	public:
		AmAudioIvrFormat();
		int getCodecId();
};

#endif
