/*
 * $Id: Ivr.h,v 1.8 2004/02/27 20:07:27 ilk Exp $
 * Copyright (C) 2002-2003 Fhg Fokus
 *
 * This file is part of sems, a free SIP media server.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
 
#ifndef _IVR_H_
#define _IVR_H_

#include "AmApi.h"
#include "SemsConfiguration.h"
#include "IvrPython.h"

#define MOD_NAME "ivr"

//#include <string>
//using std::string;

class IvrFactory: public AmStateFactory
{
	 SemsConfiguration mIvrConfig;
    string pythonScriptPath;
	 string defaultPythonScriptFile;
public:
    IvrFactory(const string& _app_name);
    int onLoad();
    AmDialogState* onInvite(AmCmd&);
};

class IvrDialog : public AmDialogState
{
    string pythonScriptFile;
    //IvrPython ivrPython;
 public:
    IvrPython* ivrPython;
    IvrDialog(string scriptFile);
    ~IvrDialog();

    void onSessionStart(AmRequest* req);
    void onBye(AmRequest* req);
    int onOther(AmSessionEvent* event);
};

#endif
