/*
 * $Id: IvrPython.h,v 1.15 2004/05/03 11:39:06 ilk Exp $
 * Copyright (C) 2002-2003 Fhg Fokus
 *
 * This file is part of sems, a free SIP media server.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#ifndef IVR_PYTHON_H
#define IVR_PYTHON_H

#include <Python.h>
#include "AmThread.h"
#include "AmSession.h"
#include "AmAudioIvr.h"
#include "IvrDtmf.h"

#define PY_MOD_NAME "ivr"


class IvrDetect: public IvrDtmf, public AmThread{
   private:
      unsigned int timeout;
      int detectedKey;
      int get_frame(pcm* buf);

   public:

      AmAudioIvr* pAmAudioIvr;
      AmSession* pAmSession;
      // Constructor  detectTimeout in milliseconds
      IvrDetect(unsigned int detectTimeout);
      int getDetectedKey();
      void run();
      void on_stop();
};



      
class IvrPython : public IvrDtmf, public AmThread{
   private:
      
      void IvrPython::setPointer(const char* pythonPrName);
      //static void* pythonThread(void*);
      //pthread_t pPythonThread;
   public:
      AmCmd* pCmd;
      char* fileName;
      bool fileOpened;
      AmSession* pAmSession;
      AmCondition<bool> isEvent;
      //AmCondition<bool> pythonStopped;             


      IvrPython();
      ~IvrPython();

      void run();
      void on_stop();
      
      /**
       * waits for Events
       + NOTIFY Event
       + timeout in milliseconds
       * return value: 1 OK
       *               0 timeout
       */
      int waitForEvent(unsigned int timeout);


      /**
       * Python extention for file playing
       */
     // PyObject* ivrPlay(PyObject *self, PyObject *args);

      /**
       * Python extention for file recording
       */
     // PyObject* ivrRecord(PyObject *self, PyObject *args);

      /**
       * Python extention for file playing & DTMF detection
       */
     // PyObject* ivrPlayAndDetect(PyObject *self, PyObject *args);

      /**
       * Python extention for DTMF detection
       */
    //  PyObject* ivrDetect(PyObject *self, PyObject *args);

      /**
       * Python extention for getting time
       */
     // PyObject* ivrGetTime(PyObject *self, PyObject *args);

      /**
       * Python extention for caller name
       */
     // PyObject* ivrGetFrom(PyObject *self, PyObject *args);

      /**
       * Python extention for callee name
       */
     // PyObject* ivrGetTo(PyObject *self, PyObject *args);

      /**
      * Python extention for callee uri
      */
      // static PyObject* ivrGetToURI(PyObject *self, PyObject *args);

      /**
      * Python extention for caller uri
      */
      // static PyObject* ivrGetFromURI(PyObject *self, PyObject *args);

      /**
       * Python extention for domain name
       */
      //static PyObject* ivrGetDomain(PyObject *self, PyObject *args);

      /**
       * Python extention for redirection
       */
     // PyObject* ivrRedirect(PyObject *self, PyObject *args);

       
};



#endif
