/*
 * $Id: NumberReader.h,v 1.3 2003/11/25 16:19:19 rco Exp $
 *
 * Copyright (C) 2002-2003 Fhg Fokus
 *
 * This file is part of sems, a free SIP media server.
 *
 * sems is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * For a license to use the sems software under conditions
 * other than those described here, or to purchase support for this
 * software, please contact iptel.org by e-mail at the following addresses:
 *    info@iptel.org
 *
 * sems is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this program; if not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef _NumberReader_h_
#define _NumberReader_h_

#include "AmApi.h"

#include <string>
using std::string;

class NumberReaderFactory: public AmStateFactory
{
public:
    static string number_path;
    static string prolog_file;
    static string epilog_file;

    NumberReaderFactory(const string& _app_name);
    virtual AmDialogState* onInvite(AmCmd&);
    virtual int onLoad();
};

class NumberReaderDialog : public AmDialogState
{
    string number;
    
 public:
    NumberReaderDialog(const string& number);
    ~NumberReaderDialog();

    virtual void onSessionStart(AmRequest* req);
    virtual void onBye(AmRequest* req);
};

#endif
// Local Variables:
// mode:C++
// End:

