#ifndef _ANNOUNCEMENT_H_
#define _ANNOUNCEMENT_H_

#include "AmApi.h"
#include "SemsConfiguration.h"
 
#include <string>
using std::string;

class SemstalkFactory: public AmStateFactory
{
    SemsConfiguration m_config;

public:
  static string FestivalServer; 
  static string FestivalPort;
  static string FestivalVoice;
  static bool Caching;
  static string CachePath;
 
  SemstalkFactory(const string& _app_name);

  int onLoad();
  AmDialogState* onInvite(AmCmd&);
};

class SemstalkDialog : public AmDialogState
{
  string festival_server;
  string festival_port;
  string festival_voice;
  bool   caching;
  string cache_path;

 public:
    SemstalkDialog(const string& FestivalServer, const string& FestivalPort, 
		      const string& FestivalVoice, const bool& caching , const string& CachePath);
    ~SemstalkDialog();

    void onSessionStart(AmRequest* req);
    void onBye(AmRequest* req);
};

#endif
// Local Variables:
// mode:C++
// End:

