#ifndef _ANNOUNCEMENT_H_
#define _ANNOUNCEMENT_H_

#include "AmApi.h"
#include "SemsConfiguration.h"
 
#include <string>
using std::string;

class TTSAnnounceFactory: public AmStateFactory
{
    SemsConfiguration m_config;

public:
  static string AnnouncePath;
  static string AnnounceFile;
  static string FestivalServer; 
  static string FestivalPort;
  static string FestivalVoice;
  static bool Caching;
  static string CachePath;
  
  TTSAnnounceFactory(const string& _app_name);

  int onLoad();
  AmDialogState* onInvite(AmCmd&);
};

class TTSAnnounceDialog : public AmDialogState
{
  string filename;
  string festival_server;
  string festival_port;
  string festival_voice;
  bool   caching;
  string cache_path;

public:
  TTSAnnounceDialog(const string& filename, const string& FestivalServer, const string& FestivalPort, 
		    const string& FestivalVoice, const bool& caching , const string& CachePath);
  ~TTSAnnounceDialog();

  void onSessionStart(AmRequest* req);
  void onBye(AmRequest* req);
};

#endif
// Local Variables:
// mode:C++
// End:

